package parser;

/**
 * Non-terminal: D1 ::= empty | D1a
 *
 * @author Mathias Ricken
 */
public interface D1 {
    /**
     * Return a string representation.
     *
     * @return string representation
     */
    public String toString();

    /**
     * Visitor hook.
     * @param v visitor
     * @param param parameter
     * @return return value
     */
    public <R, P> R execute(ID1Visitor<R, P> v, P param);

    /**
     * Visitor interface.
     */
    public interface ID1Visitor<R, P> {
        /**
         * Case for D.
         * @param host D
         * @param param parameter
         * @return return value
         */
        public R d1aCase(D1a host, P param);

        /**
         * Case for empty.
         * @param host Empty
         * @param param parameter
         * @return return value
         */
        public R emptyCase(Empty host, P param);
    }
}
