package parser;

/**
 * Non-terminal: D1a ::= ";" D
 *
 * @author Mathias Ricken
 */
public class D1a implements D1 {
    /**
     * Non-terminal: D.
     */
    private D _d;

    /**
     * Make a new D1
     * @param d D
     */
    public D1a(SemicolonToken semicolon, D d) {
        _d = d;
    }

    /**
     * Return a string representation.
     *
     * @return string representation
     */
    public String toString() {
        return SemicolonToken.Singleton.getLexeme() + '\n' + _d.toString();
    }

    /**
     * Visitor hook.
     *
     * @param v     visitor
     * @param param parameter
     * @return return value
     */
    public <R, P> R execute(ID1Visitor<R, P> v, P param) {
        return v.d1aCase(this, param);
    }

    /**
     * Get the definition.
     * @return definition
     */
    public D getDefinition() {
        return _d;
    }
}
