package parser;

/**
 * Non-terminal: E ::= T E1
 *
 * @author Mathias Ricken
 */
public class E {
    /**
     * Non-terminal: T.
     */
    private T _t;

    /**
     * Non-terminal: E1.
     */
    private E1 _e1;

    /**
     * Make a new E.
     * @param t T
     * @param e1 E1
     */
    public E(T t, E1 e1) {
        _t = t;
        _e1 = e1;
    }

    /**
     * Return a string representation.
     *
     * @return string representation
     */
    public String toString() {
        return _t.toString() + _e1.toString();
    }

    /**
     * Get the sequence.
     * @return sequence
     */
    public T getSequence() {
        return _t;
    }

    /**
     * Get the rest.
     * @return rest
     */
    public E1 getRest() {
        return _e1;
    }
}
