package parser;

/**
 * Non-terminal: E1 ::= empty | E1a
 *
 * @author Mathias Ricken
 */
public interface E1 {
    /**
     * Return a string representation.
     *
     * @return string representation
     */
    public String toString();


    /**
     * Visitor hook.
     * @param v visitor
     * @param param parameter
     * @return return value
     */
    public <R, P> R execute(IE1Visitor<R, P> v, P param);

    /**
     * Visitor interface.
     */
    public interface IE1Visitor<R, P> {
        /**
         * Case for E.
         * @param host E
         * @param param parameter
         * @return return value
         */
        public R e1aCase(E1a host, P param);

        /**
         * Case for empty.
         * @param host Empty
         * @param param parameter
         * @return return value
         */
        public R emptyCase(Empty host, P param);
    }
}
