package parser;

/**
 * Non-terminal: E1 ::= "|" E1
 *
 * @author Mathias Ricken
 */
public class E1a implements E1 {
    /**
     * Non-terminal: E.
     */
    private E _e;

    /**
     * Make a new E1.
     * @param or or token
     * @param e E
     */
    public E1a(OrToken or, E e) {
        _e = e;
    }

    /**
     * Return a string representation.
     *
     * @return string representation
     */
    public String toString() {
        return " " + OrToken.Singleton.getLexeme() + _e.toString();
    }

    /**
     * Visitor hook.
     *
     * @param v     visitor
     * @param param parameter
     * @return return value
     */
    public <R, P> R execute(IE1Visitor<R, P> v, P param) {
        return v.e1aCase(this, param);
    }

    /**
     * Get the expression.
     * @return expression
     */
    public E getExpression() {
        return _e;
    }
}
