package parser;

/**
 * Grammar terminal -- empty
 */
public class Empty implements D1, E1, T3 {
    /**
     * Singleton instance.
     */
    public final static Empty Singleton = new Empty();

    /**
     * Private singleton constructor.
     */
    private Empty() {
    }

    /**
     * Return a string representation.
     *
     * @return string representation
     */
    public String toString() {
        return "";
    }

    /**
     * Visitor hook.
     *
     * @param v     visitor
     * @param param parameter
     * @return return value
     */
    public <R, P> R execute(ID1Visitor<R, P> v, P param) {
        return v.emptyCase(this, param);
    }

    /**
     * Visitor hook.
     *
     * @param v     visitor
     * @param param parameter
     * @return return value
     */
    public <R, P> R execute(IE1Visitor<R, P> v, P param) {
        return v.emptyCase(this, param);
    }

    /**
     * Visitor hook.
     *
     * @param v     visitor
     * @param param parameter
     * @return return value
     */
    public <R, P> R execute(IT3Visitor<R, P> v, P param) {
        return v.emptyCase(this, param);
    }
}

