package parser;

/**
 * Visitor that returns the empty grammar terminal in all cases.
 */
public final class EmptyTokVis implements IVisitDefault {
    /**
     * Singleton instance.
     */
    public static EmptyTokVis Singleton = new EmptyTokVis();

    /**
     * Private singleton constructor.
     */
    private EmptyTokVis() {
    }

    /**
     * In all cases, return empty grammar terminal.
     *
     * @param host token
     * @param nu   not used
     * @return empty grammar terminal
     */
    public Object defaultCase(AToken host, Object nu) {
        return Empty.Singleton;
    }
}

