package parser;

/**
 * Interface for an abstract factory for token visitors.
 */
public interface ITVFactory {
    /**
     * Make a token visitor.
     *
     * @return token visitor
     */
    public abstract IVisitDefault makeVisitor();

    /**
     * Make a token visitor that decorates the given visitor.
     *
     * @param decoree visitor to decorate
     */
    public abstract IVisitDefault makeDecVisitor(IVisitDefault decoree);
}

