package parser;

/**
 * Non-terminal: T ::= T1 | T2
 *
 * @author Mathias Ricken
 */
public interface T extends T3 {
    /**
     * Return a string representation.
     *
     * @return string representation
     */
    public String toString();

    /**
     * Return the rest.
     *
     * @return rest
     */
    public T3 getRest();

    /**
     * Get lexeme.
     * @return lexeme
     */
    public String getLexeme();
}
