package parser;

/**
 * Non-terminal: T3 ::= empty | T
 *
 * @author Mathias Ricken
 */
public interface T3 {
    /**
     * Return a string representation.
     *
     * @return string representation
     */
    public String toString();

    /**
     * Visitor hook.
     * @param v visitor
     * @param param parameter
     * @return return value
     */
    public <R, P> R execute(IT3Visitor<R, P> v, P param);

    /**
     * Visitor interface.
     */
    public interface IT3Visitor<R, P> {
        /**
         * Case for T.
         * @param host T
         * @param param parameter
         * @return return value
         */
        public R tCase(T host, P param);

        /**
         * Case for empty.
         * @param host Empty
         * @param param parameter
         * @return return value
         */
        public R emptyCase(Empty host, P param);
    }
}
