
import output.*;

public class Test {
    /**
     * Factory for token visitors to parse D non-terminals.
     */
    private DFact dFac;

    /**
     * Tokenizer.
     */
    private ITokenizer tok;

    public static void main(String[] args) {
        (new Test()).run(args[0]);
    }

    /**
     * Constructor for the frame.
     */
    public Test() {
    }

    /**
     * Make parser.
     *
     * @throws FileNotFoundException thrown if file is not found
     */
    protected void makeParser(String fileName) throws java.io.FileNotFoundException {
        tok = new Tokenizer2(fileName);

/*
        EmptyFact emptyFact = new EmptyFact(tok);
        WordTokenFact wordFac = new WordTokenFact(tok);
        QuotedStringTokenFact qsFac = new QuotedStringTokenFact(tok);

        D_1_1Fact d_1_1Fac = new D_1_1Fact(tok);
        d_1_1Fac.set_Terminal4Fact(new _Terminal4Fact(tok));
        D_1Fact d_1Fac = new D_1Fact(tok, d_1_1Fac, emptyFact);

        E_1_1Fact e_1_1Fac = new E_1_1Fact(tok);
        e_1_1Fac.set_Terminal5Fact(new _Terminal5Fact(tok));
        E_1Fact e_1Fac = new E_1Fact(tok, e_1_1Fac, emptyFact);

        T_1Fact t_1Fac = new T_1Fact(tok);
        t_1Fac.setEmptyFact(emptyFact);
        T_2Fact t_2Fac = new T_2Fact(tok);
        t_2Fac.setEmptyFact(emptyFact);
        T_3Fact t_3Fac = new T_3Fact(tok);
        t_3Fac.setWordTokenFact(wordFac);
        T_4Fact t_4Fac = new T_4Fact(tok);
        t_4Fac.setQuotedStringTokenFact(qsFac);

        TFact tFac = new TFact(tok);
        t_1Fac.setTFact(tFac);
        t_2Fac.setTFact(tFac);
        tFac.setT_3Fact(t_3Fac);
        tFac.setT_4Fact(t_4Fac);
        t_3Fac.setT_1Fact(t_1Fac);
        t_4Fac.setT_2Fact(t_2Fac);

        EFact eFac = new EFact(tok, tFac, e_1Fac);

        dFac = new DFact(tok, wordFac, new _Terminal1Fact(tok), eFac, d_1Fac);

        e_1_1Fac.setEFact(eFac);
        d_1_1Fac.setDFact(dFac);
*/
      dFac = new DFact(tok);
    }

    void run(String fileName) {
        try {
            makeParser(fileName);

            ITokVisitor parser = dFac.makeVisitor();

            java.lang.Object result = tok.getNextToken().execute(parser, null);
            System.out.println("Grammar = " + result);
        }
        catch (Exception e1) {
            e1.printStackTrace();
        }
    }
}
