
import grammar4.*;

public class Test2 {
    /**
     * Factory for token visitors to parse D non-terminals.
     */
    private EFact eFac;

    /**
     * Tokenizer.
     */
    private ITokenizer tok;

    public static void main(String[] args) {
        (new Test2()).run(args[0]);
    }

    /**
     * Constructor for the frame.
     */
    public Test2() {
    }

    /**
     * Make parser.
     *
     * @throws FileNotFoundException thrown if file is not found
     */
    protected void makeParser(String fileName) throws java.io.FileNotFoundException {
        tok = new Tokenizer3(fileName);

        eFac = new EFact(tok);
    }

    void run(String fileName) {
        try {
            makeParser(fileName);

            ITokVisitor parser = eFac.makeVisitor();

            Object result = tok.getNextToken().execute(parser, null);
            System.out.println("Grammar = " + result);
        }
        catch (Exception e1) {
            e1.printStackTrace();
        }
    }
}
