package output;

/**
 * Non-terminal: D ::= WordToken "::=" E D1
 */
public class D {
    /**
     * Terminal: WordToken.
     */
    private WordToken _wordtoken;

    /**
     * Non-terminal: E.
     */
    private E _e;

    /**
     * Non-terminal: D1.
     */
    private D1 _d1;

    /**
     * Constructor for D.
     *
     * @param _wordtoken Terminal WordToken
     * @param __terminal1 Terminal _Terminal1
     * @param _e Non-terminal E
     * @param _d1 Non-terminal D1
     */
    public D(WordToken _wordtoken,
             _Terminal1 __terminal1,
             E _e,
             D1 _d1) {
        this._wordtoken = _wordtoken;
        this._e = _e;
        this._d1 = _d1;
    }

    /**
     * Return a string representation.
     *
     * @return string representation
     */
    public String toString() {
        return _wordtoken.toString()
             + "::="
             + _e.toString()
             + _d1.toString();
    }
}
