package output;

/**
 * Factory for D1a.
 */
public class D1aFact extends ATVFactory {
    /**
     * Visitor factory to parse _Terminal3.
     */
    private _Terminal3Fact __terminal3fact;

    /**
     * Token visitor to parse _Terminal3.
     */
    private ITokVisitor _parse_terminal3;

    /**
     * Visitor factory to parse D.
     */
    private DFact _dfact;

    /**
     * Token visitor to parse D.
     */
    private ITokVisitor _parsed;

    /**
     * Initializer lambda for this factory.
     */
    private ILambda _initializer = new ILambda() {
        public Object apply(Object param) {
            // change state to no-op
            _initializer = NoOpLambda.Singleton;

            // initialize
            _parse_terminal3 = __terminal3fact.makeVisitor();
            _parsed = _dfact.makeVisitor();
            return null;
        }
    };
    /**
     * Constructor for the D1a factory.
     *
     * @param tkz   tokenizer to use
     * @param __terminal3fact factory for _Terminal3 to use
     * @param _dfact factory for D to use
     */
    public D1aFact(ITokenizer tkz,
                   _Terminal3Fact __terminal3fact,
                   DFact _dfact) {
        super(tkz);
        this.__terminal3fact = __terminal3fact;
        this._dfact = _dfact;
    }

    /**
     * Constructor for the D1a factory.
     * This does not set the factories, they have to be set using the setXXXFact() methods.
     *
     * @param tkz   tokenizer to use
     */
    public D1aFact(ITokenizer tkz) {
        super(tkz);
    }

    /**
     * Mutator for the _Terminal3 factory.
     *
     * @param __terminal3fact factory for _Terminal3 to use
     */
    public void set_Terminal3Fact(_Terminal3Fact __terminal3fact) {
        this.__terminal3fact = __terminal3fact;
    }

    /**
     * Mutator for the D factory.
     *
     * @param _dfact factory for D to use
     */
    public void setDFact(DFact _dfact) {
        this._dfact = _dfact;
    }

    /**
     * Make a D1a.
     *
     * @param host some token
     * @param param visitor-specific input
     * @return D grammar non-terminal
     */
    private D1a makeD1a(AToken host, Object param) {
        return new D1a((_Terminal3) host.execute(_parse_terminal3, param),
                       (D) nextToken().execute(_parsed, param));
    }

    /**
     * Make a token visitor to parse an E non-terminal.
     *
     * @return token visitor
     */
    public ITokVisitor makeVisitor() {
        initialize();
        return new _Terminal3.I_Terminal3Visitor() {
            public Object _terminal3Case(_Terminal3 host, Object param) {
                return makeD1a(host, param);
            }

            public Object defaultCase(AToken host, Object param) {
                throw new IllegalArgumentException("Wrong token: '" + host + "'");
            }
        };
    }

    /**
     * Make a token visitor to parse an E non-terminal that decorates the given visitor.
     *
     * @param successor visitor to decorate
     */
    public ITokVisitor makeChainedVisitor(final ITokVisitor successor) {
        initialize();
        return new _Terminal3.I_Terminal3Visitor() {
            public Object _terminal3Case(_Terminal3 host, Object param) {
                return makeD1a(host, param);
            }

            public Object defaultCase(AToken host, Object param) {
                return host.execute(successor, param);
            }
        };
    }

    /**
     * Initialize this factory.
     */
    private void initialize() {
        _initializer.apply(null);
    }
}
