package output;

/**
 * Factory for D.
 */
public class DFact extends ATVFactory {
    /**
     * Visitor factory to parse WordToken.
     */
    private WordTokenFact _wordtokenfact;

    /**
     * Token visitor to parse WordToken.
     */
    private ITokVisitor _parsewordtoken;

    /**
     * Visitor factory to parse _Terminal1.
     */
    private _Terminal1Fact __terminal1fact;

    /**
     * Token visitor to parse _Terminal1.
     */
    private ITokVisitor _parse_terminal1;

    /**
     * Visitor factory to parse E.
     */
    private EFact _efact;

    /**
     * Token visitor to parse E.
     */
    private ITokVisitor _parsee;

    /**
     * Visitor factory to parse D1.
     */
    private D1Fact _d1fact;

    /**
     * Token visitor to parse D1.
     */
    private ITokVisitor _parsed1;

    /**
     * Initializer lambda for this factory.
     */
    private ILambda _initializer = new ILambda() {
        public Object apply(Object param) {
            // change state to no-op
            _initializer = NoOpLambda.Singleton;

            // initialize
            _parsewordtoken = _wordtokenfact.makeVisitor();
            _parse_terminal1 = __terminal1fact.makeVisitor();
            _parsee = _efact.makeVisitor();
            _parsed1 = _d1fact.makeVisitor();
            return null;
        }
    };
    /**
     * Constructor for the D factory.
     *
     * @param tkz   tokenizer to use
     * @param _wordtokenfact factory for WordToken to use
     * @param __terminal1fact factory for _Terminal1 to use
     * @param _efact factory for E to use
     * @param _d1fact factory for D1 to use
     */
    public DFact(ITokenizer tkz,
                 WordTokenFact _wordtokenfact,
                 _Terminal1Fact __terminal1fact,
                 EFact _efact,
                 D1Fact _d1fact) {
        super(tkz);
        this._wordtokenfact = _wordtokenfact;
        this.__terminal1fact = __terminal1fact;
        this._efact = _efact;
        this._d1fact = _d1fact;
    }

    /**
     * Constructor for the D factory.
     * This does not set the factories, they have to be set using the setXXXFact() methods.
     *
     * @param tkz   tokenizer to use
     */
    public DFact(ITokenizer tkz) {
        super(tkz);
    }

    /**
     * Mutator for the WordToken factory.
     *
     * @param _wordtokenfact factory for WordToken to use
     */
    public void setWordTokenFact(WordTokenFact _wordtokenfact) {
        this._wordtokenfact = _wordtokenfact;
    }

    /**
     * Mutator for the _Terminal1 factory.
     *
     * @param __terminal1fact factory for _Terminal1 to use
     */
    public void set_Terminal1Fact(_Terminal1Fact __terminal1fact) {
        this.__terminal1fact = __terminal1fact;
    }

    /**
     * Mutator for the E factory.
     *
     * @param _efact factory for E to use
     */
    public void setEFact(EFact _efact) {
        this._efact = _efact;
    }

    /**
     * Mutator for the D1 factory.
     *
     * @param _d1fact factory for D1 to use
     */
    public void setD1Fact(D1Fact _d1fact) {
        this._d1fact = _d1fact;
    }

    /**
     * Make a D.
     *
     * @param host some token
     * @param param visitor-specific input
     * @return D grammar non-terminal
     */
    private D makeD(AToken host, Object param) {
        return new D((WordToken) host.execute(_parsewordtoken, param),
                     (_Terminal1) nextToken().execute(_parse_terminal1, param),
                     (E) nextToken().execute(_parsee, param),
                     (D1) nextToken().execute(_parsed1, param));
    }

    /**
     * Make a token visitor to parse an E non-terminal.
     *
     * @return token visitor
     */
    public ITokVisitor makeVisitor() {
        initialize();
        return new WordToken.IWordTokenVisitor() {
            public Object wordTokenCase(WordToken host, Object param) {
                return makeD(host, param);
            }

            public Object defaultCase(AToken host, Object param) {
                throw new IllegalArgumentException("Wrong token: '" + host + "'");
            }
        };
    }

    /**
     * Make a token visitor to parse an E non-terminal that decorates the given visitor.
     *
     * @param successor visitor to decorate
     */
    public ITokVisitor makeChainedVisitor(final ITokVisitor successor) {
        initialize();
        return new WordToken.IWordTokenVisitor() {
            public Object wordTokenCase(WordToken host, Object param) {
                return makeD(host, param);
            }

            public Object defaultCase(AToken host, Object param) {
                return host.execute(successor, param);
            }
        };
    }

    /**
     * Initialize this factory.
     */
    private void initialize() {
        _initializer.apply(null);
    }
}
