package output;

/**
 * Factory for E1a.
 */
public class E1aFact extends ATVFactory {
    /**
     * Visitor factory to parse _Terminal4.
     */
    private _Terminal4Fact __terminal4fact;

    /**
     * Token visitor to parse _Terminal4.
     */
    private ITokVisitor _parse_terminal4;

    /**
     * Visitor factory to parse E.
     */
    private EFact _efact;

    /**
     * Token visitor to parse E.
     */
    private ITokVisitor _parsee;

    /**
     * Initializer lambda for this factory.
     */
    private ILambda _initializer = new ILambda() {
        public Object apply(Object param) {
            // change state to no-op
            _initializer = NoOpLambda.Singleton;

            // initialize
            _parse_terminal4 = __terminal4fact.makeVisitor();
            _parsee = _efact.makeVisitor();
            return null;
        }
    };
    /**
     * Constructor for the E1a factory.
     *
     * @param tkz   tokenizer to use
     * @param __terminal4fact factory for _Terminal4 to use
     * @param _efact factory for E to use
     */
    public E1aFact(ITokenizer tkz,
                   _Terminal4Fact __terminal4fact,
                   EFact _efact) {
        super(tkz);
        this.__terminal4fact = __terminal4fact;
        this._efact = _efact;
    }

    /**
     * Constructor for the E1a factory.
     * This does not set the factories, they have to be set using the setXXXFact() methods.
     *
     * @param tkz   tokenizer to use
     */
    public E1aFact(ITokenizer tkz) {
        super(tkz);
    }

    /**
     * Mutator for the _Terminal4 factory.
     *
     * @param __terminal4fact factory for _Terminal4 to use
     */
    public void set_Terminal4Fact(_Terminal4Fact __terminal4fact) {
        this.__terminal4fact = __terminal4fact;
    }

    /**
     * Mutator for the E factory.
     *
     * @param _efact factory for E to use
     */
    public void setEFact(EFact _efact) {
        this._efact = _efact;
    }

    /**
     * Make a E1a.
     *
     * @param host some token
     * @param param visitor-specific input
     * @return D grammar non-terminal
     */
    private E1a makeE1a(AToken host, Object param) {
        return new E1a((_Terminal4) host.execute(_parse_terminal4, param),
                       (E) nextToken().execute(_parsee, param));
    }

    /**
     * Make a token visitor to parse an E non-terminal.
     *
     * @return token visitor
     */
    public ITokVisitor makeVisitor() {
        initialize();
        return new _Terminal4.I_Terminal4Visitor() {
            public Object _terminal4Case(_Terminal4 host, Object param) {
                return makeE1a(host, param);
            }

            public Object defaultCase(AToken host, Object param) {
                throw new IllegalArgumentException("Wrong token: '" + host + "'");
            }
        };
    }

    /**
     * Make a token visitor to parse an E non-terminal that decorates the given visitor.
     *
     * @param successor visitor to decorate
     */
    public ITokVisitor makeChainedVisitor(final ITokVisitor successor) {
        initialize();
        return new _Terminal4.I_Terminal4Visitor() {
            public Object _terminal4Case(_Terminal4 host, Object param) {
                return makeE1a(host, param);
            }

            public Object defaultCase(AToken host, Object param) {
                return host.execute(successor, param);
            }
        };
    }

    /**
     * Initialize this factory.
     */
    private void initialize() {
        _initializer.apply(null);
    }
}
