package output;

/**
 * Terminal: QuotedStringToken.
 */
public class QuotedStringToken extends AToken
    implements T1 {
    /**
     * Interface for a visitor to visit a QuotedStringToken.
     */
    public static interface IQuotedStringTokenVisitor extends ITokVisitor {
        /**
         * Case for a QuotedStringToken.
         *
         * @param host  QuotedStringToken
         * @param param visitor-specific parameter
         * @return visitor-specific return value
         */
        public Object quotedStringTokenCase(QuotedStringToken host, Object param);
    }

    /**
     * Constructor for a QuotedStringToken.
     *
     * @param lexeme lexeme
     */
    public QuotedStringToken(String lexeme) {
        super(lexeme);
    }

    /**
     * Execute the QuotedStringToken case of the visitor.
     *
     * @param algo  visitor
     * @param param visitor-specific parameter
     * @return visitor-specific return value
     */
    public Object execute(ITokVisitor algo, Object param) {
        return (algo instanceof IQuotedStringTokenVisitor)
                ? ((IQuotedStringTokenVisitor) algo).quotedStringTokenCase(this, param)
                : algo.defaultCase(this, param);
    }
}
