package output;

/**
 * Terminal: WordToken.
 */
public class WordToken extends AToken
    implements T1 {
    /**
     * Interface for a visitor to visit a WordToken.
     */
    public static interface IWordTokenVisitor extends ITokVisitor {
        /**
         * Case for a WordToken.
         *
         * @param host  WordToken
         * @param param visitor-specific parameter
         * @return visitor-specific return value
         */
        public Object wordTokenCase(WordToken host, Object param);
    }

    /**
     * Constructor for a WordToken.
     *
     * @param lexeme lexeme
     */
    public WordToken(String lexeme) {
        super(lexeme);
    }

    /**
     * Execute the WordToken case of the visitor.
     *
     * @param algo  visitor
     * @param param visitor-specific parameter
     * @return visitor-specific return value
     */
    public Object execute(ITokVisitor algo, Object param) {
        return (algo instanceof IWordTokenVisitor)
                ? ((IWordTokenVisitor) algo).wordTokenCase(this, param)
                : algo.defaultCase(this, param);
    }
}
