package output;

/**
 * Factory for _Terminal4.
 */
public class _Terminal4Fact extends ATVFactory {
    /**
     * Constructor for the _Terminal4 factory.
     *
     * @param tkz   tokenizer to use
     */
    public _Terminal4Fact(ITokenizer tkz) {
        super(tkz);
    }


    /**
     * Make a token visitor to parse an E non-terminal.
     *
     * @return token visitor
     */
    public ITokVisitor makeVisitor() {
        return new _Terminal4.I_Terminal4Visitor() {
            public Object _terminal4Case(_Terminal4 host, Object param) {
                return host;
            }

            public Object defaultCase(AToken host, Object param) {
                throw new IllegalArgumentException("Wrong token: '" + host + "'");
            }
        };
    }

    /**
     * Make a token visitor that delegates to the given visitor in a chain of responsibility.
     *
     * @param successor visitor to serve as successor in the chain
     */
    public ITokVisitor makeChainedVisitor(final ITokVisitor successor) {
        return new _Terminal4.I_Terminal4Visitor() {
            public Object _terminal4Case(_Terminal4 host, Object param) {
                return host;
            }

            public Object defaultCase(AToken host, Object param) {
                return host.execute(successor, param);
            }
        };
    }
}
